<template>
  <div class="container">
    <h1>Тестовое</h1>
    <label for="lc">Поиск с учётом регистра?</label>
    <input type="checkbox" id="lc" v-model="checked" />
    <input
      @input="debounceInput"
      type="text"
      placeholder="Поиск"
      v-model="pattern"
    />
    <div v-if="pattern.length === 0 || !filtered">
      <Block
        v-for="(value, index) of data"
        :key="index"
        :lst="value"
        :trimmedList="trimmedList[index]"
      />
    </div>
    <div v-else-if="pattern.length > 0 && filtered">
      <Block
        v-for="(value, index) of filteredList"
        :key="index"
        :lst="value"
        :trimmedList="filteredShortList[index]"
      />
    </div>
  </div>
</template>

<script>
import Vue from "vue";
import { mapGetters, mapActions, mapMutations } from "vuex";
import { debounce } from "lodash";
export default Vue.extend({
  data() {
    return {
      pattern: "",
      checked: false
    };
  },
  methods: {
    ...mapActions(["getData", "filterList"]),
    ...mapMutations(["changeFiltered"]),
    debounceInput: debounce(function() {
      this.filterList({ pattern: this.pattern, lowerC: this.checked });
    }, 500)
  },
  computed: {
    ...mapGetters({
      data: "getData",
      trimmedList: "getTrimmedList",
      filteredList: "getFilteredList",
      filteredShortList: "getFilteredShortList",
      filtered: "getFilteredState"
    })
  },
  async fetch() {
    await this.getData();
  },
  watch: {
    pattern: function(newPattern, oldPattern) {
      if (newPattern === "") {
        this.changeFiltered(false);
      }
    }
  }
});
</script>

<style>
h1 {
  text-align: center;
}
.container {
  width: 100%;
  align-items: center;
  justify-content: center;
  text-align: center;
}
</style>
